// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "progres.h"
#include "ProgressStatusBar.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_COMMAND(ID_VIEW_PROGRESS, OnViewProgress)
	ON_COMMAND(ID_VIEW_PARALELL_PROGRESS, OnViewParalellProgress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	HDC dc=::GetDC(NULL);
	int HorRezolucija=GetDeviceCaps(dc,HORZRES);
	int VertRezolucija=GetDeviceCaps(dc,VERTRES);
	cs.cx=450;
	cs.cy=350;
	cs.x=(HorRezolucija-cs.cx)/2;
	cs.y=(VertRezolucija-cs.cy)/2;
	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	lpMMI->ptMinTrackSize.x=410;
	lpMMI->ptMinTrackSize.y=300;
	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}

void CMainFrame::OnViewProgress() 
{
	// ovaj kod ne koristiti zajedno sa multithreading varijantom
	CProgressCtrl progress; // progress kontrola
	CRect ZaProgres; // rectangle za velicinu progres kontrole
	m_wndStatusBar.GetItemRect(0,&ZaProgres); // uzmi veliinu prvog polja
	CString tekst="Testiranje:"; // string koji ispisujemo...
	CSize ZauzimaTekst=m_wndStatusBar.GetDC()->GetTextExtent(tekst); // ... i njegova irina
	ZaProgres.DeflateRect(ZauzimaTekst.cx/2,0); // za irinu teksta smanji progres
	ZaProgres.OffsetRect(ZauzimaTekst.cx/2,0); // i pomeri ga desno za isto toliko
	progress.Create(WS_VISIBLE,ZaProgres,&m_wndStatusBar,ID_PROGRES); // kreiraj progres kontrolu
	CString StariTekst=m_wndStatusBar.GetPaneText(0); // uzmi stari tekst iz prvog polja
	m_wndStatusBar.SetPaneText(0,tekst); // postavi na tekst
	m_wndStatusBar.UpdateWindow(); // forsiraj iscrtavanje
	progress.SetRange(0,15000); // postavi granice za progres... 
	progress.SetStep(3); // ... i korak
	for(int i=0;i<5000;i++)
		progress.StepIt(); // napreduj po malo kroz progres
	m_wndStatusBar.SetPaneText(0,StariTekst); // vrati stari tekst iz polja
}

void CMainFrame::OnViewParalellProgress() 
{
	CWinThread* NewThread=AfxBeginThread(NovaNit,(LPVOID)&m_wndStatusBar);
	// kreiraj novu nit i zavri						
}

UINT NovaNit(LPVOID Parametar)
{
	CProgressStatusBar* status=(CProgressStatusBar*) Parametar; // cast 
	CString* NoviTekst=new CString("Paralelno:"); // string za ispis
	bool work=status->SendMessage(WM_PROGRESS_INIT,(WPARAM)NoviTekst); 
	delete NoviTekst; // ne treba nam vie
	status->SendMessage(WM_PROGRESS_SET_RANGE,work,15000);
	status->SendMessage(WM_PROGRESS_SET_STEP,work,3);
	for(int i=0;i<5000;i++)
	{
		status->SendMessage(WM_PROGRESS_STEP_IT,work); // napreduj po malo kroz progres
		::Sleep(0); // be friendly
	}
	status->SendMessage(WM_PROGRESS_END,work); // zavri
	return 0; // kraj funkcije i ove niti
}


